<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd" >
<mapper namespace="enoxs.com.data.dao.InitSQLiteDbMapper">

	<update id="dropAppInfoTable">
		drop table if exists main.app_info
	</update>

	<update id="createAppInfoTable">
		create table app_info (
		  'id'	integer primary key autoincrement,
		  'name'	text,
		  'version'	text,
		  'author'	text,
		  'date'	text,
		  'remark'	text
		)
    </update>

	<insert id="insertAppInfoData">
		insert into app_info(name,version,author,date,remark) values
		('JavaProjSE-v1.0.3','1.0.3','Enoxs','2019-07-24' ,'Java Project Simple Example - Version 1.0.3'),
		('JUnitSE','1.0.2','Enoxs','2019-08-17' ,'Java Unit Test Simple Example'),
		('SpringMVC-SE','1.0.2','Enoxs','2019-07-31' ,'Java Web Application Spring MVC 框架 - Simple Example 未整合持久化框架（MyBatis）')
	</insert>

	<update id="dropUserInfoTable">
		drop table if exists user_info;
	</update>
	<update id="createUserInfoTable">
		create table user_info (
			'id' integer primary key autoincrement,
			'name' text,
			'account' text,
			'password' text,
			'remark' text
		);
	</update>
	<insert id="insertUserInfoData">
		insert into user_info(name,account,password,remark) values
		('夢想架構師','Enoxs','00000000','專注於 Java / Android，架構夢想的軟體開發工程師'),
		('系統管理人員','admin','root0000','最高管理權限，系統人員'),
		('測試人員','Test','0000','一般操作權限，使用者');
	</insert>

	<update id="dropAppGroupTable">
		drop table if exists app_group;
	</update>
	<update id="createAppGroupTable">
		create table app_group (
			'id' integer primary key autoincrement,
			'name' text,
			'description' text
		);
	</update>
	<insert id="insertAppGroupData">
		insert into app_group(name,description) values
		('Program','程式範例'),
		('JavaStudio','Java 程式範例'),
		('SE','Java 程式範例 SE 系列');
	</insert>

	<update id="dropAppSubGroupTable">
		drop table if exists app_sub_group;
	</update>
	<update id="createAppSubGroupTable">
		create table app_sub_group (
			'group_id' integer,
			'sub_group_id' integer
		);
	</update>
	<insert id="insertAppSubGroupData">
		insert into app_sub_group(group_id,sub_group_id) values
		(1,2),
		(2,3);
	</insert>

	<update id="dropAppGroupProjectTable">
		drop table if exists app_group_project;
	</update>
	<update id="createAppGroupProjectTable">
		create table app_group_project (
			'group_id' integer,
			'app_id' integer
		);
	</update>
	<insert id="insertAppGroupProjectData">
		insert into app_group_project(group_id,app_id) values
		(3,1),
		(3,2),
		(3,3);
	</insert>

	<select id="selectOneMapResult" resultType="java.util.Map">
		select * from app_info
		where id = #{id}
	</select>

	<select id="selectMapResult" resultType="java.util.Map">
		select * from ${tableName}
		where id = ${id}
	</select>

	<select id="selectCount" resultType="java.lang.Integer">
		select count(*) from ${tableName}
	</select>

</mapper>